
/*
 * Copyright (c) 1997 Carter Bullard
 * All applicable rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation is restricted to personal use only.  Use, sale
 * or retransmission of this software for commercial purposes, 
 * including but not limited to use as a commerical product or
 * in support of a commercial endeavor requires licensing from Carter
 * Bullard.
 *
 * CARTER BULLARD DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS, IN NO EVENT SHALL CARTER BULLARD BE LIABLE FOR ANY
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

/*
 * Copyright (c) 1993, 1994 Carnegie Mellon University.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted, 
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear
 * in supporting documentation, and that the name of CMU not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  
 * 
 * CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 *
 */

/*
 * cons_ether.c - handle datagrams at link layer - ethernet specific.
 *                just branch to IP datagram handler if appropriate.
 *
 * written by Carter Bullard
 * Software Engineering Institute
 * Carnegie Mellon Univeristy
 *
 */

#if !defined(HAVE_SOLARIS)
#include <stdlib.h>
#include <unistd.h>
#endif

#include <sys/types.h>
#include <sys/time.h>

#include <compat.h>
#include <pcap.h>

#include <cons_ether.h>

#include <netinet/in.h>
#include <argus.h>


void
cons_ether_init ()
{
}

struct timeval globaltvp;
int totalPktsRcv = 0;
int totalBytesRcv = 0;

extern char *rfile;
extern void check_all_timeouts();

void 
cons_ether_packet (user, h, p)
u_char *user;
struct pcap_pkthdr *h;
u_char *p;
{
   struct ether_header ep;
   struct argtimeval tvpbuf, *tvp = &tvpbuf;
   u_short ether_type;
   int caplen = h->caplen;
   int length = h->len;

   if (p && caplen) {
      totalPktsRcv++;

      globaltvp.tv_sec  = h->ts.tv_sec;
      globaltvp.tv_usec = h->ts.tv_usec;
      tvp->tv_sec = h->ts.tv_sec;
      tvp->tv_usec = h->ts.tv_usec;
      bcopy ((char *) p, (char *) &ep, sizeof (ep));

      if (rfile)
         if (updatetime (tvp))
            check_all_timeouts (tvp);

      if (ether_type = ntohs (ep.ether_type)) {
         length -= sizeof (struct ether_header);
         totalBytesRcv += length;
         switch (ether_type) {
            case ETHERTYPE_IP:
               argus_ip_handler (p, p + sizeof (ep), length, tvp);
               break;

            default:
               /* argus_handler (p, p + sizeof (ep), length, tvp, ether_type); */
               break;
         }
      }
   }
}
